using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_BG_UMV_HA41
{
    public class UserModuleClass_BG_UMV_HA41 : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        Crestron.Logos.SplusObjects.DigitalInput REBOOT;
        Crestron.Logos.SplusObjects.DigitalInput FACTORY_RESET;
        Crestron.Logos.SplusObjects.AnalogInput SET_VIDEO_ROUTING_A;
        Crestron.Logos.SplusObjects.AnalogInput SET_VIDEO_ROUTING_B;
        Crestron.Logos.SplusObjects.AnalogInput SET_VIDEO_ROUTING_C;
        Crestron.Logos.SplusObjects.AnalogInput SET_VIDEO_ROUTING_D;
        Crestron.Logos.SplusObjects.AnalogInput SET_LAYOUT;
        Crestron.Logos.SplusObjects.AnalogInput SET_AUDIO_MIX;
        Crestron.Logos.SplusObjects.AnalogInput SET_AUDIO_MUTE;
        Crestron.Logos.SplusObjects.AnalogInput SET_AUDIO_SRC;
        Crestron.Logos.SplusObjects.AnalogInput SET_OUTPUT_RESOLUTION;
        Crestron.Logos.SplusObjects.StringOutput TX__DOLLAR__;
        object REBOOT_OnPush_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                
                __context__.SourceCodeLine = 164;
                TX__DOLLAR__  .UpdateValue ( "#REBOOT\u000D\u000A"  ) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object FACTORY_RESET_OnPush_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            
            __context__.SourceCodeLine = 169;
            TX__DOLLAR__  .UpdateValue ( "#FACTORY_RESET\u000D\u000A"  ) ; 
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object SET_VIDEO_ROUTING_A_OnChange_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 183;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_VIDEO_ROUTING_A  .UshortValue) ; 
        __context__.SourceCodeLine = 184;
        TX__DOLLAR__  .UpdateValue ( "#SET_AV " + STRINGINPUT1 + " TO A\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_VIDEO_ROUTING_B_OnChange_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 193;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_VIDEO_ROUTING_B  .UshortValue) ; 
        __context__.SourceCodeLine = 194;
        TX__DOLLAR__  .UpdateValue ( "#SET_AV " + STRINGINPUT1 + " TO B\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_VIDEO_ROUTING_C_OnChange_4 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 203;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_VIDEO_ROUTING_C  .UshortValue) ; 
        __context__.SourceCodeLine = 204;
        TX__DOLLAR__  .UpdateValue ( "#SET_AV " + STRINGINPUT1 + " TO C\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_VIDEO_ROUTING_D_OnChange_5 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 214;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_VIDEO_ROUTING_D  .UshortValue) ; 
        __context__.SourceCodeLine = 215;
        TX__DOLLAR__  .UpdateValue ( "#SET_AV " + STRINGINPUT1 + " TO D\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_LAYOUT_OnChange_6 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
        
        
        __context__.SourceCodeLine = 224;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_LAYOUT  .UshortValue) ; 
        __context__.SourceCodeLine = 225;
        TX__DOLLAR__  .UpdateValue ( "#SET_MV_MODE " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_AUDIO_MIX_OnChange_7 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 234;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_AUDIO_MIX  .UshortValue) ; 
        __context__.SourceCodeLine = 235;
        TX__DOLLAR__  .UpdateValue ( "#SET_AUDIO_MIX " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_AUDIO_MUTE_OnChange_8 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 245;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_AUDIO_MUTE  .UshortValue) ; 
        __context__.SourceCodeLine = 246;
        TX__DOLLAR__  .UpdateValue ( "#SET_AUDIO_MUTE " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_AUDIO_SRC_OnChange_9 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 255;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_AUDIO_SRC  .UshortValue) ; 
        __context__.SourceCodeLine = 256;
        TX__DOLLAR__  .UpdateValue ( "#SET_AUDIO_SRC " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_OUTPUT_RESOLUTION_OnChange_10 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 265;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_OUTPUT_RESOLUTION  .UshortValue) ; 
        __context__.SourceCodeLine = 266;
        TX__DOLLAR__  .UpdateValue ( "#SET_OUTPUT_RES " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}


public override void LogosSplusInitialize()
{
    SocketInfo __socketinfo__ = new SocketInfo( 1, this );
    InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
    _SplusNVRAM = new SplusNVRAM( this );
    
    REBOOT = new Crestron.Logos.SplusObjects.DigitalInput( REBOOT__DigitalInput__, this );
    m_DigitalInputList.Add( REBOOT__DigitalInput__, REBOOT );
    
    FACTORY_RESET = new Crestron.Logos.SplusObjects.DigitalInput( FACTORY_RESET__DigitalInput__, this );
    m_DigitalInputList.Add( FACTORY_RESET__DigitalInput__, FACTORY_RESET );
    
    SET_VIDEO_ROUTING_A = new Crestron.Logos.SplusObjects.AnalogInput( SET_VIDEO_ROUTING_A__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_VIDEO_ROUTING_A__AnalogSerialInput__, SET_VIDEO_ROUTING_A );
    
    SET_VIDEO_ROUTING_B = new Crestron.Logos.SplusObjects.AnalogInput( SET_VIDEO_ROUTING_B__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_VIDEO_ROUTING_B__AnalogSerialInput__, SET_VIDEO_ROUTING_B );
    
    SET_VIDEO_ROUTING_C = new Crestron.Logos.SplusObjects.AnalogInput( SET_VIDEO_ROUTING_C__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_VIDEO_ROUTING_C__AnalogSerialInput__, SET_VIDEO_ROUTING_C );
    
    SET_VIDEO_ROUTING_D = new Crestron.Logos.SplusObjects.AnalogInput( SET_VIDEO_ROUTING_D__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_VIDEO_ROUTING_D__AnalogSerialInput__, SET_VIDEO_ROUTING_D );
    
    SET_LAYOUT = new Crestron.Logos.SplusObjects.AnalogInput( SET_LAYOUT__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_LAYOUT__AnalogSerialInput__, SET_LAYOUT );
    
    SET_AUDIO_MIX = new Crestron.Logos.SplusObjects.AnalogInput( SET_AUDIO_MIX__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_AUDIO_MIX__AnalogSerialInput__, SET_AUDIO_MIX );
    
    SET_AUDIO_MUTE = new Crestron.Logos.SplusObjects.AnalogInput( SET_AUDIO_MUTE__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_AUDIO_MUTE__AnalogSerialInput__, SET_AUDIO_MUTE );
    
    SET_AUDIO_SRC = new Crestron.Logos.SplusObjects.AnalogInput( SET_AUDIO_SRC__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_AUDIO_SRC__AnalogSerialInput__, SET_AUDIO_SRC );
    
    SET_OUTPUT_RESOLUTION = new Crestron.Logos.SplusObjects.AnalogInput( SET_OUTPUT_RESOLUTION__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_OUTPUT_RESOLUTION__AnalogSerialInput__, SET_OUTPUT_RESOLUTION );
    
    TX__DOLLAR__ = new Crestron.Logos.SplusObjects.StringOutput( TX__DOLLAR____AnalogSerialOutput__, this );
    m_StringOutputList.Add( TX__DOLLAR____AnalogSerialOutput__, TX__DOLLAR__ );
    
    
    REBOOT.OnDigitalPush.Add( new InputChangeHandlerWrapper( REBOOT_OnPush_0, false ) );
    FACTORY_RESET.OnDigitalPush.Add( new InputChangeHandlerWrapper( FACTORY_RESET_OnPush_1, false ) );
    SET_VIDEO_ROUTING_A.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_VIDEO_ROUTING_A_OnChange_2, false ) );
    SET_VIDEO_ROUTING_B.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_VIDEO_ROUTING_B_OnChange_3, false ) );
    SET_VIDEO_ROUTING_C.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_VIDEO_ROUTING_C_OnChange_4, false ) );
    SET_VIDEO_ROUTING_D.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_VIDEO_ROUTING_D_OnChange_5, false ) );
    SET_LAYOUT.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_LAYOUT_OnChange_6, false ) );
    SET_AUDIO_MIX.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_AUDIO_MIX_OnChange_7, false ) );
    SET_AUDIO_MUTE.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_AUDIO_MUTE_OnChange_8, false ) );
    SET_AUDIO_SRC.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_AUDIO_SRC_OnChange_9, false ) );
    SET_OUTPUT_RESOLUTION.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_OUTPUT_RESOLUTION_OnChange_10, false ) );
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    
    
}

public UserModuleClass_BG_UMV_HA41 ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint REBOOT__DigitalInput__ = 0;
const uint FACTORY_RESET__DigitalInput__ = 1;
const uint SET_VIDEO_ROUTING_A__AnalogSerialInput__ = 0;
const uint SET_VIDEO_ROUTING_B__AnalogSerialInput__ = 1;
const uint SET_VIDEO_ROUTING_C__AnalogSerialInput__ = 2;
const uint SET_VIDEO_ROUTING_D__AnalogSerialInput__ = 3;
const uint SET_LAYOUT__AnalogSerialInput__ = 4;
const uint SET_AUDIO_MIX__AnalogSerialInput__ = 5;
const uint SET_AUDIO_MUTE__AnalogSerialInput__ = 6;
const uint SET_AUDIO_SRC__AnalogSerialInput__ = 7;
const uint SET_OUTPUT_RESOLUTION__AnalogSerialInput__ = 8;
const uint TX__DOLLAR____AnalogSerialOutput__ = 0;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
